// HORB
// Class: Remote3_Proxy
// Version: 0.0
// Date: Sun Oct 14 12:45:14 JST 2001
// Generator: HORBC Compiler 2.1. b2
//
import horb.orb.*;
import java.io.*;

public  class Remote3_Proxy  implements horb.orb.Proxy {
  protected short classNo;
  public final static short major = 0;
  public final static short minor = 0;
  public short _getMajorVersion() { return major;}
  public short _getMinorVersion() { return minor;}
  protected HorbURL url;
  private transient IOCI ioci;
  public IOCI _getIOCI() { return ioci; }
  public void _setIOCI(IOCI ioci) { this.ioci = ioci; }
  public HorbURL _getObjectURL() { return url; }
  public Remote3_Proxy() {
    classNo = 1;
  }
  public synchronized void _connect(HorbURL url, String user, Object identification) throws HORBException {
    try {
      if (ioci == null)
        ioci = (HORB.getFactory(url.getProtocol())).createIOCI();
    } catch (Exception e) {
      throw new HORBException("can't create IOCI: "+e);
    }
    this.url = ioci.connect(url, "Remote3",major, minor, user, identification, horb.orb.transport.HORBSession.MULTIPLE, null);
  }
  public synchronized void _release() {
    ioci.releaseObject();
    ioci = null;
  }
  public Remote3_Proxy(HorbURL url) throws HORBException {
    this(url, null, null);
  }
  public Remote3_Proxy(String surl) throws HORBException {
    this(new HorbURL(surl), null, null);
  }
  public Remote3_Proxy(HorbURL url, String user, Object identification) throws HORBException {
    this();
    try{
    _connect(url, user, identification);
    } catch(RemoteException re) {
      IOCI io = _getIOCI();
      Throwable e = null;
      try {
        e = io.recvException();
      } catch (IOException ioe) {
        throw new NetException(ioe);
      }
      if (e == null)
      throw new RemoteException("remote exception occured.");
      throw new RemoteException(e.toString());
    }
  }
  public int longJob_Async(int arg0)  {
    IOCI io = _getIOCI();
    try {
    io.methodStart();
    io.selectMethod(classNo, 1001);
    io.sendInt(arg0);
    io.kick();
    } catch (IOException ioe) {
      io.methodEnd();
      throw new NetException(ioe);
    }
    try {
    short stat = io.recvStatus();
    int retValue;
    retValue= io.recvInt();
    return retValue;
    } catch(RemoteException re) {
      Throwable e = null;
      try {
        e = io.recvException();
      } catch (IOException ioe) {
        throw new NetException(ioe);
      }
      if (e == null)
      throw new RemoteException("remote exception occured.");
      throw new RemoteException(e.toString());
    } catch (IOException ioe) {
      throw new NetException(ioe);
    }finally {
      io.methodEnd();
    }
  }
  public ResultAsync  longJob_Request(int arg0)  {
    Object[] args    =  {new Integer(arg0)};
    Class[]  argTypes = {int.class};
    IOCI io = _getIOCI();
    return io.startAsyncCall(this,"longJob",args,argTypes); 
  }
  public void  _callbackFromThread_longJob_Request(int arg0) {
    IOCI io = _getIOCI();
    try{
    io.methodStart();
    io.selectMethod(classNo, 1001);
    io.sendInt(arg0);
    io.kick();
    } catch (IOException ioe) {
      throw new NetException(ioe);
    }
  }
  public int longJob_Receive(ResultAsync obj)  {
    if (obj.isException()) {
      Throwable e = obj.receiveException();
      if (e == null)
      throw new RemoteException("remote exception occured.");
      throw new RemoteException(e.toString());
    }
    return (int)(obj.receiveInt());
  }

  public  int longJob_Receive(ResultAsync obj,long timeout) throws InterruptedException {
    obj.waiting(timeout);
    return longJob_Receive(obj);
  }

  public int _callbackFromThread_longJob_Receive() throws InterruptedException {
    IOCI io = _getIOCI();
    try {
    int retValue;
    retValue= io.recvInt();
    io.methodEnd();
    return retValue;
    } catch (IOException ioe) {
      io.methodEnd();
      throw new NetException(ioe);
    }
  }
  public void _sendInstance(IOCI io, Object obj, Loopy loopy, byte place) throws HORBException, IOException {
  }
  public Object _recvInstance(IOCI io, Object obj, boolean superclass, Goldberg gb, byte place) throws HORBException, IOException {
    Remote3 o = null;
    if (superclass) {
      o = (Remote3)obj;
    } else {
      try {
        o = new Remote3();
      } catch(Throwable t) {
        throw new HORBException("Exception occured during receiving an object: "+t);
      }
      gb.put(o);
    }
    return (Object)o;
  }
   private void readObject(java.io.ObjectInputStream in)
      throws IOException, ClassNotFoundException {
         in.defaultReadObject();
         if ( in instanceof horb.orb.transport.HORBObjectInputStream )
            this._connect( this.url, 
               ((horb.orb.transport.HORBObjectInputStream)in).username,
               ((horb.orb.transport.HORBObjectInputStream)in).identification );
         else
            this._connect( this.url,"", "" );
   }
  public boolean equals(Object o){
    if (this == o) return true;
    if (o instanceof Remote3_Proxy) { /* uses toString() to compares */
      return this.toString().equals(o.toString());
    }
    else if (o instanceof Remote3) {
      return o.equals(this);
    }
    return false;
  }
  public int hashCode(){ /* return remote object's hashCode() */
    if (url != null) {
      return url.getObjectHashCode();
    }
    return super.hashCode();
  }
  public String toString() { /* return "<host>:<host's processID>:<objectID>" */
    if (url != null) {
      return url.getObjectHostAddress()+":"+url.getObjectProcessID()+":"+url.getObjectID();
    }
    return super.toString();
  }
  public void _setHandler(AsyncMethodHandler handler, int tag) {
    _getIOCI().setAsyncMethodHandler(handler, tag);
  }
  private static String[][] methodInfo = {
    {"", "Remote3", "void", "1000"},
    {"int", "longJob_Async", "int", "1001"},
  };
  public static String[][] getMethodInfo(){
    return methodInfo;
  }
}
